464. Can I Win

87 篇文章 0 订阅

In the "100 game," two players take turns adding, to a running total, any integer from 1..10. The player who first causes the running total to reach or exceed 100 wins.

What if we change the game so that players cannot re-use integers?

For example, two players might take turns drawing from a common pool of numbers of 1..15 without replacement until they reach a total >= 100.

Given an integer maxChoosableInteger and another integer desiredTotal, determine if the first player to move can force a win, assuming both players play optimally.

You can always assume that maxChoosableInteger will not be larger than 20 and desiredTotal will not be larger than 300.

Example

Input:
maxChoosableInteger = 10
desiredTotal = 11

Output:
false

Explanation:
No matter which integer the first player choose, the first player will lose.
The first player can choose an integer from 1 up to 10.
If the first player choose 1, the second player can only choose integers from 2 up to 10.
The second player will win by choosing 10 and get a total = 11, which is >= desiredTotal.
Same with other integers chosen by the first player, the second player will always win.


方向确定不了,只能memo


After solving several "Game Playing" questions in leetcode, I find them to be pretty similar. Most of them can be solved using the top-down DP approach, which "brute-forcely" simulates every possible state of the game.

The key part for the top-down dp strategy is that we need to avoid repeatedly solving sub-problems. Instead, we should use some strategy to "remember" the outcome of sub-problems. Then when we see them again, we instantly know their result. By doing this, we can always reduce time complexity from exponential to polynomial.
(EDIT: Thanks for @billbirdh for pointing out the mistake here. For this problem, by applying the memo, we at most compute for every subproblem once, and there are O(2^n) subproblems, so the complexity is O(2^n) after memorization. (Without memo, time complexity should be like O(n!))

For this question, the key part is: what is the state of the game? Intuitively, to uniquely determine the result of any state, we need to know:

  1. The unchosen numbers
  2. The remaining desiredTotal to reach

A second thought reveals that 1) and 2) are actually related because we can always get the 2) by deducting the sum of chosen numbers from original desiredTotal.

Then the problem becomes how to describe the state using 1).

In my solution, I use a boolean array to denote which numbers have been chosen, and then a question comes to mind, if we want to use a Hashmap to remember the outcome of sub-problems, can we just use Map<boolean[], Boolean> ? Obviously we cannot, because the if we use boolean[] as a key, the reference to boolean[] won't reveal the actual content in boolean[].

Since in the problem statement, it says maxChoosableInteger will not be larger than 20, which means the length of our boolean[] array will be less than 20. Then we can use an Integer to represent this boolean[] array. How?

Say the boolean[] is {false, false, true, true, false}, then we can transfer it to an Integer with binary representation as00110. Since Integer is a perfect choice to be the key of HashMap, then we now can "memorize" the sub-problems usingMap<Integer, Boolean>.

The rest part of the solution is just simulating the game process using the top-down dp.



package l464;

import java.util.HashMap;

/*
 * 之前遇到的问题是:想用Memo,但是状态不好描述,因为可能取走1..n中间的某个数
 * 这样状态就不得不用一个数组描述,然后就卡在这里了
 * 
 * So,数组就数组嘛,先把它转成String再放到HashMap里面(TLE)
 * 
 * 然后题目说最大20,那其实不用数组再转String,直接用个Int就好了
 */
public class Solution {
	
    public boolean canIWin(int maxChoosableInteger, int desiredTotal) {
    	if(desiredTotal <= 0)	return true;
    	if((1+maxChoosableInteger)*maxChoosableInteger/2 < desiredTotal)	return false;
    	return canIWin(desiredTotal, 0, maxChoosableInteger, new HashMap<Integer, Boolean>());
    }

	private boolean canIWin(int total, int state, int n, HashMap<Integer, Boolean> map) {
		if(map.containsKey(state))	return map.get(state);
		
		for(int i=0; i<n; i++) {
			if((state&(1<<i)) == 0) {
				if(total<=i+1 || !canIWin(total-(i+1), state|(1<<i), n, map)) {
					map.put(state, true);
					return true;
				}
			}
		}
		
		map.put(state, false);
		return false;
	}


}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值